package me.lysne.thesis.levert;

import net.semanticmetadata.lire.imageanalysis.LireFeature;
import net.semanticmetadata.lire.impl.ChainedDocumentBuilder;
import net.semanticmetadata.lire.impl.GenericDocumentBuilder;
import net.semanticmetadata.lire.indexing.parallel.ParallelIndexer;

import java.io.File;

public class Indexer {

    private File indexDir;
    private File imgDir;
    private Class<? extends LireFeature> descriptor;

    private Indexer(File indexDir, File imgDir) {
        this.indexDir = indexDir;
        this.imgDir = imgDir;
    }

    public Indexer(File indexDir, File imgDir, Class<? extends LireFeature> desriptor) {
        this(indexDir, imgDir);
        this.descriptor = desriptor;
    }

    public void start(int numThreads) {

        if (!indexDir.exists() && !indexDir.mkdir())
            return;
        else if (!imgDir.exists())
            return;
        else if (numThreads <= 0)
            numThreads = 1;

        ParallelIndexer parallelIndexer = new ParallelIndexer(
                numThreads, indexDir.getAbsolutePath(), imgDir.getAbsolutePath()) {
            @Override
            public void addBuilders(ChainedDocumentBuilder builder) {
                builder.addBuilder(new GenericDocumentBuilder(descriptor));
            }
        };
        parallelIndexer.run();
    }
}
